#region Copyright
// Copyright Syncfusion Inc. 2001 - 2014. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion

using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.Data;
using System.Data.OleDb;
using System.Linq;
using System.Security.Permissions;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml;



public class EmployeeDetails
{

    [DataObjectMethod(DataObjectMethodType.Select)]
    public List<Employee> GetRecords()
    {
        string date = "2000-02-02";
        int id = 100;
        List<Employee> list = new List<Employee>();
        if ((List<Employee>)HttpContext.Current.Session["DataSource"] == null)
        {
            for (var i = 0; i < 9; i++)
            {
                list.Add(new Employee(id, "John", "UK", "Nancy", "Sales Representative", new DateTime(2010, 1, 18)));
                list.Add(new Employee(id + 1, "Tom", "USA", "Andrew", "Sales Manager", DateTime.Parse(date)));
                list.Add(new Employee(id + 2, "Bretney", "USA", "Janet", "Sales Manager", new DateTime(837714600000)));
                list.Add(new Employee(id + 3, "Jessy", "UK", "Margaret", "Sales Coordinator", new DateTime(664732800000)));
                list.Add(new Employee(id + 4, "Bruch", "USA", "Peacock", "Vice President", new DateTime(840006000000)));
                list.Add(new Employee(id + 5, "Johny", "USA", "Callahan", "Sales Representative", new DateTime(842425200000)));
                id += 6;
            }
            HttpContext.Current.Session["DataSource"] = list;   
        }
        else
        {
            list = (List<Employee>)HttpContext.Current.Session["DataSource"];
        }
        return list;
    }
    [DataObjectMethod(DataObjectMethodType.Insert)]
    public void Insert(object record)
    {
        List<Employee> data = HttpContext.Current.Session["DataSource"] as List<Employee>;
        Dictionary<string, object> KeyVal = record as Dictionary<string, object>;
        Employee i = new Employee();
        i.EmployeeID = Convert.ToInt32(KeyVal["EmployeeID"]);
        i.FirstName = KeyVal["FirstName"].ToString();
        i.LastName = KeyVal["LastName"].ToString();
        i.Title = KeyVal["Title"].ToString();
        i.JoinDate = Convert.ToDateTime(KeyVal["JoinDate"]);
        i.Country = KeyVal["Country"].ToString();
        data.Insert(0, i);
    }
    [DataObjectMethod(DataObjectMethodType.Update)]
    public void Update(object record)
    {
        List<Employee> data = HttpContext.Current.Session["DataSource"] as List<Employee>;
        Dictionary<string, object> KeyVal = record as Dictionary<string, object>;
        Employee i = data.Where(o => o.EmployeeID == Convert.ToInt32(KeyVal["EmployeeID"])).FirstOrDefault();
        if (i != null)
        {
            i.FirstName = KeyVal["FirstName"].ToString();
            i.LastName = KeyVal["LastName"].ToString();
            i.Title = KeyVal["Title"].ToString();
            i.JoinDate = Convert.ToDateTime(KeyVal["JoinDate"]);
            i.Country = KeyVal["Country"].ToString();
        }
    }
    [DataObjectMethod(DataObjectMethodType.Delete)]
    public void Delete(object record)
    {
        List<Employee> data = HttpContext.Current.Session["DataSource"] as List<Employee>;
        Dictionary<string, object> KeyVal = record as Dictionary<string, object>;
        if (HttpContext.Current.Session["DataSource"] != null)
        {
            Employee i = data.Where(o => o.EmployeeID == Convert.ToInt32(KeyVal["EmployeeID"])).FirstOrDefault();
            data.Remove(i);
        }
    }
}


[Serializable]
public class Employee
{
    public string _country;
    public int _empID;
    public string _firstName;
    public string _lastname;
    public string _title;
    public DateTime _testDate;

    public Employee()
    {

    }

    public Employee(int _empID, string _firstName, string _country, string _lastname, string _title, DateTime _testDate)
    {
        this._empID = _empID;
        this._firstName = _firstName;
        this._country = _country;
        this._lastname = _lastname;
        this._title = _title;
        this._testDate = _testDate;
    }

    public string Country
    {
        get
        {
            return _country;
        }
        set
        {
            _country = value;
        }
    }

    public int EmployeeID
    {
        get
        {
            return _empID;
        }
        set
        {
            _empID = value;
        }
    }

    public string FirstName
    {
        get
        {
            return _firstName;
        }
        set
        {
            _firstName = value;
        }
    }

    public string LastName
    {
        get
        {
            return _lastname;
        }
        set
        {
            _lastname = value;
        }
    }

    public string Title
    {
        get
        {
            return _title;
        }
        set
        {
            _title = value;
        }
    }
    public DateTime JoinDate
    {
        get
        {
            return _testDate;
        }
        set
        {
            _testDate = value;
        }
    }
}