﻿using Syncfusion.JavaScript.Web;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Sample.Models;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;

namespace Sample
{
    public partial class _Default : Page
    {
        DataTable dt = new DataTable("Order");
        protected void Page_Load(object sender, EventArgs e)
        {           
            LoadGridData();
        }        

        private void LoadGridData()
        {
            SqlConnection myConnection = new SqlConnection(ConfigurationManager.ConnectionStrings["NORTHWNDConnectionString"].ToString());
            dt = new DataTable("Order");
            SqlCommand cmd = new SqlCommand();
            cmd.Connection = myConnection;
            cmd.CommandText = "select * from Orders";
            cmd.CommandType = CommandType.Text;
            SqlDataAdapter da = new SqlDataAdapter();
            da.SelectCommand = cmd;
            if (myConnection.State == ConnectionState.Closed)
            {
                myConnection.Open();
            }
            da.Fill(dt);
            Session["SqlDataSource"] = dt;
            FlatGrid.DataSource = dt;
            FlatGrid.DataBind();
        }

        protected void grd_ServerDeleteRow(object sender, Syncfusion.JavaScript.Web.GridEventArgs e)
        {
            EditAction(e.EventType, e.Arguments["data"]);
        }

        protected void grd_ServerAddRow(object sender, Syncfusion.JavaScript.Web.GridEventArgs e)
        {
            EditAction(e.EventType, e.Arguments["data"]);
        }

        protected void grd_ServerEditRow(object sender, Syncfusion.JavaScript.Web.GridEventArgs e)
        {
            EditAction(e.EventType, e.Arguments["data"]);
        }               

        protected void EditAction(string eventType, object record)
        {
            SqlConnection myConnection = new SqlConnection(ConfigurationManager.ConnectionStrings["NORTHWNDConnectionString"].ToString());
            dt = Session["SqlDataSource"] as DataTable;
            Dictionary<string, object> KeyVal = record as Dictionary<string, object>;
            if (eventType == "endEdit")
            {
                var Order = KeyVal.Values.ToArray();
                foreach (DataRow dr in dt.Rows)
                {
                    if (Convert.ToInt32(dr["OrderID"]) == Convert.ToInt32(Order[0]))
                    {
                        dr["CustomerID"] = Order[1];
                        dr["EmployeeID"] = Order[2];                        
                        dr["ShipCountry"] = Order[3];
                        dr.AcceptChanges();
                    }

                }
            }

            else if (eventType == "endAdd")
            {
                var Order = KeyVal.Values.ToArray();
                DataRow dr = dt.NewRow();
                dr["OrderID"] = Order[0];
                dr["EmployeeID"] = Order[1];
                dr["Freight"] = Order[2];
                dr["ShipCity"] = Order[3];
                dr["ShipCountry"] = Order[4];
                dt.Rows.Add(dr);
            }
            else if (eventType == "endDelete")
            {
                var Order = KeyVal.Values.ToArray();
                if (Session["SqlDataSource"] != null)
                {
                    DataRow[] rows = dt.Select("OrderID = " + Order[0]);

                    foreach (DataRow row in rows)
                        dt.Rows.Remove(row);

                }
            }
            Session["SqlDataSource"] = dt;
            FlatGrid.DataSource = dt;
            FlatGrid.DataBind();
        }
    }
}